import { __values, __extends } from 'tslib';
import { BehaviorSubject } from 'rxjs';
import { zoomIdentity, select, zoom, event } from 'd3';
import { Injectable, Component, Input, NgModule, defineInjectable, inject } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PrimitiveElement = /** @class */ (function () {
    function PrimitiveElement() {
    }
    return PrimitiveElement;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PrimitiveRect = /** @class */ (function (_super) {
    __extends(PrimitiveRect, _super);
    function PrimitiveRect() {
        var _this = _super.call(this) || this;
        _this.rx = 2,
            _this.ry = 2,
            _this.type = 'rect';
        _this.width = 0;
        _this.height = 0;
        _this.position = { x: 0, y: 0 };
        _this.cssClass = 'bpmn-flows-rect';
        _this.textCssClass = 'bpmn-flows-text';
        _this.iconCssClass = 'bpmn-flows-task-icon';
        return _this;
    }
    return PrimitiveRect;
}(PrimitiveElement));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var UserTaskRect = /** @class */ (function (_super) {
    __extends(UserTaskRect, _super);
    function UserTaskRect() {
        var _this = _super.call(this) || this;
        _this.icon = 'fa fa-user';
        return _this;
    }
    return UserTaskRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PrimitiveCircle = /** @class */ (function (_super) {
    __extends(PrimitiveCircle, _super);
    function PrimitiveCircle() {
        var _this = _super.call(this) || this;
        _this.type = 'circle';
        _this.ratio = null;
        _this.position = { x: 0, y: 0 };
        _this.cssClass = 'bpmn-flows-circle';
        _this.textCssClass = 'bpmn-flows-circle-name';
        return _this;
    }
    /**
     * @param {?} ratio
     * @return {?}
     */
    PrimitiveCircle.prototype.setRatio = /**
     * @param {?} ratio
     * @return {?}
     */
    function (ratio) {
        this.width = ratio;
        this.height = ratio;
        this.ratio = ratio;
    };
    return PrimitiveCircle;
}(PrimitiveElement));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var StartEventCircle = /** @class */ (function (_super) {
    __extends(StartEventCircle, _super);
    function StartEventCircle() {
        return _super.call(this) || this;
    }
    return StartEventCircle;
}(PrimitiveCircle));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var EndEventCircle = /** @class */ (function (_super) {
    __extends(EndEventCircle, _super);
    function EndEventCircle() {
        var _this = _super.call(this) || this;
        _this.cssClass += ' bpmn-flows-end-event-circle';
        return _this;
    }
    return EndEventCircle;
}(PrimitiveCircle));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var MultiInstanceRect = /** @class */ (function (_super) {
    __extends(MultiInstanceRect, _super);
    function MultiInstanceRect() {
        return _super.call(this) || this;
    }
    return MultiInstanceRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PrimitiveSequence = /** @class */ (function (_super) {
    __extends(PrimitiveSequence, _super);
    function PrimitiveSequence() {
        var _this = _super.call(this) || this;
        _this.waypoints = [];
        return _this;
    }
    return PrimitiveSequence;
}(PrimitiveElement));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SequenceFlowPath = /** @class */ (function (_super) {
    __extends(SequenceFlowPath, _super);
    function SequenceFlowPath() {
        var _this = _super.call(this) || this;
        _this.cssClass = 'bpmn-flows-path';
        _this.textCssClass = 'bpmn-flows-path-name';
        return _this;
    }
    return SequenceFlowPath;
}(PrimitiveSequence));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PrimitiveRhombus = /** @class */ (function (_super) {
    __extends(PrimitiveRhombus, _super);
    function PrimitiveRhombus() {
        var _this = _super.call(this) || this;
        _this.rx = 2,
            _this.ry = 2,
            _this.type = 'polygon';
        _this.width = 0;
        _this.height = 0;
        _this.position = { x: 0, y: 0 };
        _this.points = '';
        _this.textCssClass = 'bpmn-flows-text';
        _this.cssClass = 'bpmn-flows-gateway';
        _this.iconCssClass = 'bpmn-flows-gateway-icon';
        return _this;
    }
    return PrimitiveRhombus;
}(PrimitiveElement));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ExclusiveGatewayRhombus = /** @class */ (function (_super) {
    __extends(ExclusiveGatewayRhombus, _super);
    function ExclusiveGatewayRhombus() {
        var _this = _super.call(this) || this;
        _this.icon = 'fa fa-times';
        return _this;
    }
    return ExclusiveGatewayRhombus;
}(PrimitiveRhombus));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ParallelGatewayRhombus = /** @class */ (function (_super) {
    __extends(ParallelGatewayRhombus, _super);
    function ParallelGatewayRhombus() {
        var _this = _super.call(this) || this;
        _this.icon = 'fa fa-plus';
        return _this;
    }
    return ParallelGatewayRhombus;
}(PrimitiveRhombus));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ManualTaskRect = /** @class */ (function (_super) {
    __extends(ManualTaskRect, _super);
    function ManualTaskRect() {
        var _this = _super.call(this) || this;
        _this.icon = 'fa fa-handshake';
        return _this;
    }
    return ManualTaskRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ScriptTaskRect = /** @class */ (function (_super) {
    __extends(ScriptTaskRect, _super);
    function ScriptTaskRect() {
        var _this = _super.call(this) || this;
        _this.icon = 'fa fa-code';
        return _this;
    }
    return ScriptTaskRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var LaneRect = /** @class */ (function (_super) {
    __extends(LaneRect, _super);
    function LaneRect() {
        var _this = _super.call(this) || this;
        _this.childLanes = [];
        _this.flowRefs = [];
        _this.textCssClass = 'bpmn-flows-lane-name';
        return _this;
    }
    return LaneRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ParticipantRect = /** @class */ (function (_super) {
    __extends(ParticipantRect, _super);
    function ParticipantRect() {
        var _this = _super.call(this) || this;
        _this.lanes = [];
        _this.textCssClass = 'bpmn-flows-lane-name';
        return _this;
    }
    return ParticipantRect;
}(PrimitiveRect));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var BpmnTypes = {
    'userTask': UserTaskRect,
    'scriptTask': ScriptTaskRect,
    'manualTask': ManualTaskRect,
    'startEvent': StartEventCircle,
    'endEvent': EndEventCircle,
    'subProcess': MultiInstanceRect,
    'sequenceFlow': SequenceFlowPath,
    'exclusiveGateway': ExclusiveGatewayRhombus,
    'parallelGateway': ParallelGatewayRhombus,
    'lane': LaneRect,
    'participant': ParticipantRect
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Shape = /** @class */ (function () {
    function Shape(xmlShape) {
        this.childrens = [];
        this.form = xmlShape.form;
        this.id = xmlShape.id;
        this.name = xmlShape.name;
        this.in = [];
        this.out = [];
        this.element = new BpmnTypes[xmlShape.type]();
    }
    return Shape;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SequenceFlow = /** @class */ (function () {
    function SequenceFlow(id, name, source, target) {
        this.id = id;
        this.name = name;
        this.source = source;
        this.target = target;
        this.element = new SequenceFlowPath();
    }
    return SequenceFlow;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var BpmnElements = /** @class */ (function () {
    function BpmnElements() {
        this.shapes = {};
        this.sequences = {};
    }
    /**
     * @return {?}
     */
    BpmnElements.prototype.bindElementAndSequence = /**
     * @return {?}
     */
    function () {
        var e_1, _a;
        /** @type {?} */
        var sequenceKeys = Object.keys(this.sequences);
        try {
            for (var sequenceKeys_1 = __values(sequenceKeys), sequenceKeys_1_1 = sequenceKeys_1.next(); !sequenceKeys_1_1.done; sequenceKeys_1_1 = sequenceKeys_1.next()) {
                var sequenceKey = sequenceKeys_1_1.value;
                /** @type {?} */
                var sequence = this.sequences[sequenceKey];
                sequence.source.out.push(sequence);
                sequence.target.in.push(sequence);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (sequenceKeys_1_1 && !sequenceKeys_1_1.done && (_a = sequenceKeys_1.return)) _a.call(sequenceKeys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @param {?} size
     * @return {?}
     */
    BpmnElements.prototype.calculateRhombusPoints = /**
     * @param {?} size
     * @return {?}
     */
    function (size) {
        return size / 2 + ',0 ' + size + ',' + size / 2 + ' ' + size / 2 + ',' + size + ' 0,' + size / 2;
    };
    /**
     * @param {?} xmlElement
     * @return {?}
     */
    BpmnElements.prototype.createElement = /**
     * @param {?} xmlElement
     * @return {?}
     */
    function (xmlElement) {
        /** @type {?} */
        var shape = new Shape(xmlElement);
        this.shapes[shape.id] = shape;
        return shape;
    };
    /**
     * @param {?} id
     * @param {?} name
     * @param {?} source
     * @param {?} target
     * @return {?}
     */
    BpmnElements.prototype.createSequence = /**
     * @param {?} id
     * @param {?} name
     * @param {?} source
     * @param {?} target
     * @return {?}
     */
    function (id, name, source, target) {
        /** @type {?} */
        var sourceShape = this.shapes[source];
        /** @type {?} */
        var targetShape = this.shapes[target];
        if (!sourceShape || !targetShape) {
            console.warn(source);
            console.warn(target);
            throw new Error('Sequencia incompleta.');
        }
        /** @type {?} */
        var sequence = new SequenceFlow(id, name, sourceShape, targetShape);
        this.sequences[id] = sequence;
    };
    /**
     * @param {?} id
     * @param {?} position
     * @return {?}
     */
    BpmnElements.prototype.setSequenceNamePlacement = /**
     * @param {?} id
     * @param {?} position
     * @return {?}
     */
    function (id, position) {
        /** @type {?} */
        var sequence = this.sequences[id];
        sequence.element.textPosition = position;
    };
    /**
     * @param {?} id
     * @param {?} waypoints
     * @return {?}
     */
    BpmnElements.prototype.setSequenceWaypoints = /**
     * @param {?} id
     * @param {?} waypoints
     * @return {?}
     */
    function (id, waypoints) {
        /** @type {?} */
        var sequence = this.sequences[id];
        if (!sequence) {
            throw new Error('Sequência não criada: ' + id);
        }
        /** @type {?} */
        var element = sequence.element;
        element.waypoints.push(waypoints);
    };
    /**
     * @param {?} id
     * @param {?} width
     * @param {?} height
     * @param {?} position
     * @return {?}
     */
    BpmnElements.prototype.setShapeAttributes = /**
     * @param {?} id
     * @param {?} width
     * @param {?} height
     * @param {?} position
     * @return {?}
     */
    function (id, width, height, position) {
        /** @type {?} */
        var shape = this.shapes[id];
        if (!shape) {
            console.warn('Shape não existe: ' + id);
            throw new Error('Shape não conhecida.');
        }
        if (shape.element instanceof PrimitiveRect) {
            /** @type {?} */
            var element = shape.element;
            element.width = width;
            element.height = height;
            element.position = position;
        }
        else if (shape.element instanceof PrimitiveCircle) {
            /** @type {?} */
            var element = shape.element;
            /** @type {?} */
            var ratio = ((width + height) / 4);
            element.setRatio(ratio);
            element.position = position;
        }
        else if (shape.element instanceof PrimitiveRhombus) {
            /** @type {?} */
            var element = shape.element;
            element.width = width;
            element.height = height;
            element.position = position;
            element.points = this.calculateRhombusPoints(element.width);
        }
        else {
            console.warn(shape.element);
            throw new Error('Shape não conhecida.');
        }
    };
    /**
     * @param {?} id
     * @param {?} position
     * @return {?}
     */
    BpmnElements.prototype.setShapeNamePlacement = /**
     * @param {?} id
     * @param {?} position
     * @return {?}
     */
    function (id, position) {
        /** @type {?} */
        var shape = this.shapes[id];
        shape.element.textPosition = position;
    };
    return BpmnElements;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var BpmnImporter = /** @class */ (function () {
    function BpmnImporter(xml) {
        this.bpmnElements = new BpmnElements();
        this.bpmnElements$ = new BehaviorSubject(null);
        this.getElements(xml);
    }
    /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    BpmnImporter.prototype.createLane = /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    function (dom, type, father) {
        var e_1, _a, e_2, _b, e_3, _c;
        /** @type {?} */
        var childs = this.htmlCollectionToArray(dom.children);
        if (type === 'laneSet') {
            try {
                for (var childs_1 = __values(childs), childs_1_1 = childs_1.next(); !childs_1_1.done; childs_1_1 = childs_1.next()) {
                    var lane = childs_1_1.value;
                    this.importElement(lane, null);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (childs_1_1 && !childs_1_1.done && (_a = childs_1.return)) _a.call(childs_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return;
        }
        /** @type {?} */
        var xmlElement = {
            id: dom.getAttribute('id'),
            name: dom.getAttribute('name'),
            type: type
        };
        /** @type {?} */
        var shape = this.bpmnElements.createElement(xmlElement);
        /** @type {?} */
        var element = /** @type {?} */ (shape.element);
        if (father) {
            shape.father = father;
        }
        try {
            for (var childs_2 = __values(childs), childs_2_1 = childs_2.next(); !childs_2_1.done; childs_2_1 = childs_2.next()) {
                var child = childs_2_1.value;
                if (child.tagName === 'bpmn:flowNodeRef') {
                    element.flowRefs.push(child.childNodes[0]);
                }
                else if (child.tagName === 'bpmn:childLaneSet') {
                    /** @type {?} */
                    var laneChilds = this.htmlCollectionToArray(child.children);
                    try {
                        for (var laneChilds_1 = __values(laneChilds), laneChilds_1_1 = laneChilds_1.next(); !laneChilds_1_1.done; laneChilds_1_1 = laneChilds_1.next()) {
                            var laneChild = laneChilds_1_1.value;
                            shape.childrens.push(this.importElement(laneChild, shape));
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (laneChilds_1_1 && !laneChilds_1_1.done && (_c = laneChilds_1.return)) _c.call(laneChilds_1);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (childs_2_1 && !childs_2_1.done && (_b = childs_2.return)) _b.call(childs_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return shape;
    };
    /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    BpmnImporter.prototype.createShape = /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    function (dom, type, father) {
        try {
            /** @type {?} */
            var xmlElement = {
                form: dom.getAttribute('camunda:formKey'),
                id: dom.getAttribute('id'),
                name: dom.getAttribute('name'),
                type: type
            };
            /** @type {?} */
            var shape = this.bpmnElements.createElement(xmlElement);
            if (father) {
                shape.father = father;
            }
            return shape;
        }
        catch (ex) {
            console.warn(dom);
            console.warn('Tipo não possui shape associado: ' + type);
        }
    };
    /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    BpmnImporter.prototype.createSubProcess = /**
     * @param {?} dom
     * @param {?} type
     * @param {?} father
     * @return {?}
     */
    function (dom, type, father) {
        var _this = this;
        /** @type {?} */
        var childs = this.htmlCollectionToArray(dom.children);
        /** @type {?} */
        var sequences = [];
        /** @type {?} */
        var xmlElement = {
            form: dom.getAttribute('camunda:formKey'),
            id: dom.getAttribute('id'),
            name: dom.getAttribute('name'),
            type: type
        };
        /** @type {?} */
        var shape = this.bpmnElements.createElement(xmlElement);
        if (father) {
            shape.father = father;
        }
        childs.forEach(function (child) {
            /** @type {?} */
            var tagName = child.tagName;
            if (tagName === 'bpmn:incoming') ;
            else if (tagName === 'bpmn:outgoing') ;
            else if (tagName === 'bpmn:sequenceFlow') {
                sequences.push(child);
            }
            else if (child.tagName !== 'bpmn:multiInstanceLoopCharacteristics') {
                shape.childrens.push(_this.importElement(child, shape));
            }
        });
        sequences.forEach(function (sequence) {
            _this.importSequenceFlow(sequence);
        });
        return shape;
    };
    /**
     * @param {?} xml
     * @return {?}
     */
    BpmnImporter.prototype.getElements = /**
     * @param {?} xml
     * @return {?}
     */
    function (xml) {
        this.collaboration = xml.getElementsByTagName('bpmn:collaboration')[0];
        this.process = xml.getElementsByTagName('bpmn:process')[0];
        this.diagram = xml.getElementsByTagName('bpmndi:BPMNDiagram')[0];
        this.processCollaboration();
        this.processBpmnProcess();
        this.processDiagram();
        this.bpmnElements.bindElementAndSequence();
        this.bpmnElements$.next(this.bpmnElements);
    };
    /**
     * @param {?} node
     * @return {?}
     */
    BpmnImporter.prototype.getNodePosition = /**
     * @param {?} node
     * @return {?}
     */
    function (node) {
        return { x: parseInt(node.getAttribute('x')), y: parseInt(node.getAttribute('y')) };
    };
    /**
     * @param {?} doms
     * @return {?}
     */
    BpmnImporter.prototype.htmlCollectionToArray = /**
     * @param {?} doms
     * @return {?}
     */
    function (doms) {
        /** @type {?} */
        var childs = [];
        for (var i = 0; i < doms.length; i++) {
            childs.push(doms[i]);
        }
        return childs;
    };
    /**
     * @param {?} dom
     * @param {?} father
     * @return {?}
     */
    BpmnImporter.prototype.importElement = /**
     * @param {?} dom
     * @param {?} father
     * @return {?}
     */
    function (dom, father) {
        /** @type {?} */
        var type = dom.tagName.split(':')[1];
        if (type === 'subProcess') {
            return this.createSubProcess(dom, type, father);
        }
        else if (type === 'laneSet' || type === 'lane') {
            return this.createLane(dom, type, father);
        }
        else {
            return this.createShape(dom, type, father);
        }
    };
    /**
     * @param {?} sequence
     * @return {?}
     */
    BpmnImporter.prototype.importSequenceFlow = /**
     * @param {?} sequence
     * @return {?}
     */
    function (sequence) {
        /** @type {?} */
        var source = sequence.getAttribute('sourceRef');
        /** @type {?} */
        var target = sequence.getAttribute('targetRef');
        /** @type {?} */
        var id = sequence.getAttribute('id');
        /** @type {?} */
        var name = sequence.getAttribute('name');
        this.bpmnElements.createSequence(id, name, source, target);
    };
    /**
     * @return {?}
     */
    BpmnImporter.prototype.processCollaboration = /**
     * @return {?}
     */
    function () {
        var e_4, _a;
        /** @type {?} */
        var childs = this.htmlCollectionToArray(this.collaboration.children);
        try {
            for (var childs_3 = __values(childs), childs_3_1 = childs_3.next(); !childs_3_1.done; childs_3_1 = childs_3.next()) {
                var child = childs_3_1.value;
                if (child.tagName === 'bpmn:participant') {
                    this.importElement(child, null);
                }
                else {
                    console.warn('Collaboration not known: ' + child.tagName);
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (childs_3_1 && !childs_3_1.done && (_a = childs_3.return)) _a.call(childs_3);
            }
            finally { if (e_4) throw e_4.error; }
        }
    };
    /**
     * @return {?}
     */
    BpmnImporter.prototype.processBpmnProcess = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var childs = this.htmlCollectionToArray(this.process.children);
        /** @type {?} */
        var sequenceFlows = childs.filter(function (child) { return child.tagName === 'bpmn:sequenceFlow'; });
        /** @type {?} */
        var elements = childs.filter(function (child) { return child.tagName !== 'bpmn:sequenceFlow'; });
        this.bpmnElements.processId = this.process.getAttribute('id');
        this.bpmnElements.processName = this.process.getAttribute('name');
        elements.forEach(function (element) { return _this.importElement(element, null); });
        sequenceFlows.forEach(function (sequence) { return _this.importSequenceFlow(sequence); });
    };
    /**
     * @return {?}
     */
    BpmnImporter.prototype.processDiagram = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var plane = this.diagram.getElementsByTagName('bpmndi:BPMNPlane')[0];
        /** @type {?} */
        var childs = plane.childNodes;
        childs.forEach(function (child) {
            if (child.tagName) {
                if (child.tagName === 'bpmndi:BPMNShape') {
                    _this.processShapes(child);
                }
                else if (child.tagName === 'bpmndi:BPMNEdge') {
                    _this.processSequences(child);
                }
                else {
                    console.warn('Elemento do diagrama não conhecido: ' + child.tagName);
                }
            }
        });
    };
    /**
     * @param {?} child
     * @return {?}
     */
    BpmnImporter.prototype.processSequences = /**
     * @param {?} child
     * @return {?}
     */
    function (child) {
        var _this = this;
        /** @type {?} */
        var id = child.getAttribute('bpmnElement');
        /** @type {?} */
        var childNodes = child.childNodes;
        childNodes.forEach(function (node) {
            _this.processSequenceChild(id, node);
        });
    };
    /**
     * @param {?} id
     * @param {?} node
     * @return {?}
     */
    BpmnImporter.prototype.processSequenceChild = /**
     * @param {?} id
     * @param {?} node
     * @return {?}
     */
    function (id, node) {
        if (node.nodeName !== '#text') {
            if (node.tagName === 'di:waypoint') {
                /** @type {?} */
                var position = this.getNodePosition(node);
                this.bpmnElements.setSequenceWaypoints(id, position);
            }
            else if (node.tagName === 'bpmndi:BPMNLabel') {
                /** @type {?} */
                var position = this.getNodePosition(node.childNodes[1]);
                this.bpmnElements.setSequenceNamePlacement(id, position);
            }
        }
    };
    /**
     * @param {?} child
     * @return {?}
     */
    BpmnImporter.prototype.processShapes = /**
     * @param {?} child
     * @return {?}
     */
    function (child) {
        var _this = this;
        /** @type {?} */
        var id = child.getAttribute('bpmnElement');
        /** @type {?} */
        var childNodes = child.childNodes;
        childNodes.forEach(function (node) {
            _this.processShapeChild(id, node);
        });
    };
    /**
     * @param {?} id
     * @param {?} node
     * @return {?}
     */
    BpmnImporter.prototype.processShapeChild = /**
     * @param {?} id
     * @param {?} node
     * @return {?}
     */
    function (id, node) {
        if (node.nodeName !== '#text') {
            if (node.tagName === 'dc:Bounds') {
                /** @type {?} */
                var position = this.getNodePosition(node);
                /** @type {?} */
                var height = parseInt(node.getAttribute('height'));
                /** @type {?} */
                var width = parseInt(node.getAttribute('width'));
                this.bpmnElements.setShapeAttributes(id, width, height, position);
            }
            else if (node.tagName === 'bpmndi:BPMNLabel') {
                /** @type {?} */
                var position = this.getNodePosition(node.childNodes[1]);
                this.bpmnElements.setShapeNamePlacement(id, position);
            }
            else {
                console.warn(node);
                console.warn('Elemento não conhecido.');
            }
        }
    };
    return BpmnImporter;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Scene = /** @class */ (function () {
    function Scene(bpmnElements, sceneClass) {
        this.bpmnElements = bpmnElements;
        this.sceneClass = sceneClass;
        this.centerEye = {};
        this.loaded$ = new BehaviorSubject(false);
        this.svgScene = null;
        this.svgSceneElements = null;
        this.svgSceneShapes = null;
        this.svgSceneSequences = null;
        this.svgSceneDefs = null;
        this.sequences = this.bpmnElements.sequences;
        this.shapes = this.bpmnElements.shapes;
    }
    /**
     * @return {?}
     */
    Scene.prototype.init = /**
     * @return {?}
     */
    function () {
        this.loadSceneEngine();
        this.loadElements();
        this.calculateCenterEye();
        this.loaded$.next(true);
    };
    /**
     * @return {?}
     */
    Scene.prototype.calculateCenterEye = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var bpmnFlowsContainer = document.getElementsByClassName(this.sceneClass)[0];
        /** @type {?} */
        var bpmnWidth = Math.abs(this.centerEye.maxX - this.centerEye.minX);
        /** @type {?} */
        var bpmnHeight = Math.abs(this.centerEye.maxY - this.centerEye.minY);
        /** @type {?} */
        var translateXFix = (this.centerEye.minX < 0) ? this.centerEye.minX * -1 : 0;
        /** @type {?} */
        var translateYFix = (this.centerEye.minY < 0) ? this.centerEye.minY * -1 : 0;
        /** @type {?} */
        var width = bpmnFlowsContainer.clientWidth;
        /** @type {?} */
        var height = bpmnFlowsContainer.clientHeight;
        /** @type {?} */
        var scale = 1;
        while ((bpmnWidth * scale) > width || (bpmnHeight * scale) > height) {
            scale -= 0.03;
        }
        /** @type {?} */
        var translateX = translateXFix + 20;
        /** @type {?} */
        var translateY = translateYFix;
        /** @type {?} */
        var centeredZoom = zoomIdentity.translate(translateX, translateY).scale(scale);
        this.zoomEye.call(this.zoomBehaviour.transform, centeredZoom);
    };
    /**
     * @param {?} sequence
     * @return {?}
     */
    Scene.prototype.calculatePath = /**
     * @param {?} sequence
     * @return {?}
     */
    function (sequence) {
        /** @type {?} */
        var waypoints = sequence.element.waypoints;
        /** @type {?} */
        var d = 'm ' + waypoints[0].x + ', ' + waypoints[0].y;
        for (var waypoint = 1; waypoint < waypoints.length; waypoint++) {
            d += 'L' + waypoints[waypoint].x + ',' + waypoints[waypoint].y;
        }
        return d;
    };
    /**
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.calculateTextposition = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        /** @type {?} */
        var x = element.textPosition.x - element.position.x + 20;
        /** @type {?} */
        var y = element.textPosition.y - element.position.y + 10;
        return x + ',' + y;
    };
    /**
     * @return {?}
     */
    Scene.prototype.loadDefs = /**
     * @return {?}
     */
    function () {
        this.svgSceneDefs.append('defs').append('marker')
            .attr('id', 'marker_arrow')
            .attr('markerHeight', 10)
            .attr('markerWidth', 12)
            .attr('markerUnits', 'strokeWidth')
            .attr('orient', 'auto')
            .attr('refX', 9.5)
            .attr('refY', 10)
            .attr('viewBox', '0 0 22 22')
            .append('path')
            .attr('d', 'M 1 5 L 11 10 L 1 15 Z')
            .attr('class', 'bpmn-flows-marker');
    };
    /**
     * @return {?}
     */
    Scene.prototype.loadElements = /**
     * @return {?}
     */
    function () {
        this.loadDefs();
        this.loadShapes();
        this.loadSequences();
    };
    /**
     * @return {?}
     */
    Scene.prototype.loadShapes = /**
     * @return {?}
     */
    function () {
        var e_1, _a;
        /** @type {?} */
        var shapesKeys = Object.keys(this.shapes);
        try {
            for (var shapesKeys_1 = __values(shapesKeys), shapesKeys_1_1 = shapesKeys_1.next(); !shapesKeys_1_1.done; shapesKeys_1_1 = shapesKeys_1.next()) {
                var shapesKey = shapesKeys_1_1.value;
                /** @type {?} */
                var shape = this.shapes[shapesKey];
                shape.element.svgElement = this.svgSceneShapes.append('g');
                if (shape.element instanceof PrimitiveCircle) {
                    this.renderCircle(shape, shape.element);
                }
                else if (shape.element instanceof PrimitiveRect) {
                    this.renderRect(shape, shape.element);
                }
                else if (shape.element instanceof PrimitiveRhombus) {
                    this.renderRhombus(shape, shape.element);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (shapesKeys_1_1 && !shapesKeys_1_1.done && (_a = shapesKeys_1.return)) _a.call(shapesKeys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @return {?}
     */
    Scene.prototype.loadSceneEngine = /**
     * @return {?}
     */
    function () {
        this.svgScene = select('.' + this.sceneClass).append('svg');
        this.svgScene.attr('class', 'bpmn-flows-svg-scene');
        this.svgSceneElements = this.svgScene.append('g');
        this.svgSceneDefs = this.svgSceneElements.append('g');
        this.svgSceneSequences = this.svgSceneElements.append('g');
        this.svgSceneShapes = this.svgSceneElements.append('g');
        this.zoomEngine();
    };
    /**
     * @return {?}
     */
    Scene.prototype.loadSequences = /**
     * @return {?}
     */
    function () {
        var e_2, _a;
        /** @type {?} */
        var sequencesKeys = Object.keys(this.sequences);
        try {
            for (var sequencesKeys_1 = __values(sequencesKeys), sequencesKeys_1_1 = sequencesKeys_1.next(); !sequencesKeys_1_1.done; sequencesKeys_1_1 = sequencesKeys_1.next()) {
                var sequenceKey = sequencesKeys_1_1.value;
                /** @type {?} */
                var sequence = this.sequences[sequenceKey];
                sequence.element.svgElement = this.svgSceneSequences.append('g');
                this.renderSequence(sequence);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (sequencesKeys_1_1 && !sequencesKeys_1_1.done && (_a = sequencesKeys_1.return)) _a.call(sequencesKeys_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderCircle = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var name = shape.name;
        /** @type {?} */
        var circle = element.svgElement.append('circle');
        circle.attr('cx', '16');
        circle.attr('cy', '16');
        circle.attr('r', element.ratio);
        circle.attr('class', element.cssClass);
        if (name) {
            /** @type {?} */
            var text = element.svgElement.append('text');
            /** @type {?} */
            var translate = this.calculateTextposition(element);
            text.attr('class', element.textCssClass);
            text.attr('transform', 'translate(' + translate + ')');
            text.text(name);
        }
        element.svgElement.attr('transform', 'translate( ' + element.position.x + ', ' + element.position.y + ' )');
        this.setCenterEye(element.position, element.width, element.height);
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderRect = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var rec = element.svgElement.append('rect');
        rec.attr('id', shape.id);
        rec.attr('width', element.width);
        rec.attr('height', element.height);
        rec.attr('class', element.cssClass);
        if (element instanceof MultiInstanceRect) {
            this.renderMultiInstance(shape, element);
        }
        else if (element instanceof ParticipantRect || element instanceof LaneRect) {
            this.renderLane(shape, element);
        }
        else {
            this.renderTask(shape, element);
        }
        element.svgElement.attr('transform', 'translate( ' + element.position.x + ', ' + element.position.y + ' )');
        this.setCenterEye(element.position, element.width, element.height);
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderRhombus = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var polygon = element.svgElement.append('polygon');
        /** @type {?} */
        var foreignObject = element.svgElement.append('foreignObject').attr('y', 0).attr('x', 0);
        /** @type {?} */
        var div = foreignObject.append('xhtml:div');
        /** @type {?} */
        var name = shape.name;
        polygon.attr('points', element.points);
        polygon.attr('width', element.width);
        polygon.attr('height', element.height);
        polygon.attr('class', element.cssClass);
        if (name) {
            /** @type {?} */
            var text = element.svgElement.append('text');
            /** @type {?} */
            var translate = this.calculateTextposition(element);
            text.attr('class', element.textCssClass);
            text.attr('transform', 'translate(' + translate + ')');
            text.text(name);
        }
        div.attr('style', 'float:left; width: ' + (element.width) + 'px; height:' + (element.height) + 'px;');
        div.attr('class', element.icon + ' ' + element.iconCssClass);
        element.svgElement.attr('transform', 'translate( ' + element.position.x + ', ' + element.position.y + ' )');
        this.setCenterEye(element.position, element.width, element.height);
    };
    /**
     * @param {?} sequence
     * @return {?}
     */
    Scene.prototype.renderSequence = /**
     * @param {?} sequence
     * @return {?}
     */
    function (sequence) {
        /** @type {?} */
        var sequenceElement = /** @type {?} */ (sequence.element);
        /** @type {?} */
        var path = sequenceElement.svgElement.append('path');
        path.attr('id', sequence.id);
        path.attr('class', sequenceElement.cssClass);
        path.attr('d', this.calculatePath(sequence));
        path.attr('marker-end', 'url(#marker_arrow)');
        if (sequence.name) {
            /** @type {?} */
            var text = sequenceElement.svgElement.append('text');
            text.attr('class', sequenceElement.textCssClass);
            text.attr('transform', 'translate(' + (sequenceElement.textPosition.x) + ',' + (sequenceElement.textPosition.y + 10) + ')');
            text.text(sequence.name);
        }
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderLane = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var text = element.svgElement.append('text');
        text.attr('class', element.textCssClass);
        text.attr('x', -element.height / 2);
        text.attr('y', 15);
        text.text(shape.name);
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderMultiInstance = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var name = shape.name;
        if (name) {
            /** @type {?} */
            var text = element.svgElement.append('text');
            text.attr('class', element.textCssClass);
            text.text(name);
            text.attr('line-height', '1.2');
            text.attr('y', 20);
            text.attr('x', element.width / 2);
        }
    };
    /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    Scene.prototype.renderTask = /**
     * @param {?} shape
     * @param {?} element
     * @return {?}
     */
    function (shape, element) {
        /** @type {?} */
        var taskName = shape.name;
        if (element.icon) {
            element.svgElement.append('foreignObject').attr('y', 5).attr('x', 5)
                .append('xhtml:span').attr('class', element.iconCssClass + ' ' + element.icon);
        }
        if (taskName) {
            /** @type {?} */
            var text = element.svgElement.append('text');
            text.attr('class', element.textCssClass);
            text.text(taskName);
            text.attr('line-height', '1.2');
            text.attr('y', (element.height / 2) + 5);
            text.attr('x', element.width / 2);
        }
        this.setCenterEye(element.position, element.width, element.height);
    };
    /**
     * @param {?} position
     * @param {?} width
     * @param {?} height
     * @return {?}
     */
    Scene.prototype.setCenterEye = /**
     * @param {?} position
     * @param {?} width
     * @param {?} height
     * @return {?}
     */
    function (position, width, height) {
        if (!this.centerEye.maxX) {
            this.centerEye.maxX = position.x;
            this.centerEye.minX = position.x;
            this.centerEye.minY = position.y;
            this.centerEye.maxY = position.y;
            return;
        }
        if (this.centerEye.minX > position.x) {
            this.centerEye.minX = position.x;
        }
        if (this.centerEye.maxX < position.x + width) {
            this.centerEye.maxX = position.x + width;
        }
        if (this.centerEye.minY > position.y) {
            this.centerEye.minY = position.y;
        }
        if (this.centerEye.maxY < position.y + height) {
            this.centerEye.maxY = position.y + height;
        }
    };
    /**
     * @param {?} transform
     * @param {?} shapes
     * @return {?}
     */
    Scene.prototype.zoomed = /**
     * @param {?} transform
     * @param {?} shapes
     * @return {?}
     */
    function (transform, shapes) {
        shapes.attr('transform', transform);
    };
    /**
     * @return {?}
     */
    Scene.prototype.zoomEngine = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.zoomBehaviour = zoom()
            .scaleExtent([1 / 2, 4])
            .on('zoom', function () { return _this.zoomed(event.transform, _this.svgSceneElements); });
        this.zoomEye = this.svgScene.append('rect');
        this.zoomEye.attr('class', 'bpmn-flows-zoom-eye');
        this.zoomEye.call(this.zoomBehaviour);
    };
    return Scene;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var BpmnFlowsService = /** @class */ (function () {
    function BpmnFlowsService(http) {
        this.http = http;
    }
    /**
     * @param {?} bpmnFile
     * @return {?}
     */
    BpmnFlowsService.prototype.initialize = /**
     * @param {?} bpmnFile
     * @return {?}
     */
    function (bpmnFile) {
        this.getBpmnDiagram(bpmnFile);
    };
    /**
     * @param {?} text
     * @return {?}
     */
    BpmnFlowsService.prototype.bpmnDiagramParser = /**
     * @param {?} text
     * @return {?}
     */
    function (text) {
        /** @type {?} */
        var parser = new DOMParser();
        /** @type {?} */
        var xml = parser.parseFromString(text, "text/xml");
        this.bpmnImporter = new BpmnImporter(xml);
        this.eventImportedBpmn();
    };
    /**
     * @return {?}
     */
    BpmnFlowsService.prototype.eventImportedBpmn = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.bpmnImporter.bpmnElements$.subscribe(function (bpmnElements) {
            _this.bpmnElements = bpmnElements;
            if (_this.bpmnElements) {
                _this.renderBpmn();
            }
        });
    };
    /**
     * @return {?}
     */
    BpmnFlowsService.prototype.eventRenderedBpmn = /**
     * @return {?}
     */
    function () {
        this.scene.loaded$.subscribe(function (loaded) {
        });
    };
    /**
     * @param {?} bpmnFilePath
     * @return {?}
     */
    BpmnFlowsService.prototype.getBpmnDiagram = /**
     * @param {?} bpmnFilePath
     * @return {?}
     */
    function (bpmnFilePath) {
        var _this = this;
        this.http.get(bpmnFilePath, { responseType: 'text' }).subscribe(function (response) {
            _this.bpmnDiagramParser(response);
        });
    };
    /**
     * @return {?}
     */
    BpmnFlowsService.prototype.renderBpmn = /**
     * @return {?}
     */
    function () {
        this.scene = new Scene(this.bpmnElements, 'bpmn-flows-container');
        this.scene.init();
        this.eventRenderedBpmn();
    };
    BpmnFlowsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    BpmnFlowsService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ BpmnFlowsService.ngInjectableDef = defineInjectable({ factory: function BpmnFlowsService_Factory() { return new BpmnFlowsService(inject(HttpClient)); }, token: BpmnFlowsService, providedIn: "root" });
    return BpmnFlowsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var BpmnFlowsComponent = /** @class */ (function () {
    function BpmnFlowsComponent(bpmnFlowsService) {
        this.bpmnFlowsService = bpmnFlowsService;
    }
    /**
     * @return {?}
     */
    BpmnFlowsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.bpmnFlowsService.initialize(this.fileUrl);
    };
    BpmnFlowsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'bpmn-flows',
                    template: "<div class = \"bpmn-flows-container\">\r\n</div>",
                    styles: [".bpmn-flows-container{float:left;box-sizing:border-box;height:100%;width:100%;position:relative;overflow-x:hidden;overflow-y:hidden}.bpmn-flows-svg-scene{height:5000px;width:5000px;position:relative}.bpmn-flows-circle,.bpmn-flows-gateway,.bpmn-flows-rect{fill:none;stroke:#6b6a6a}.bpmn-flows-end-event-circle{stroke-width:3px}.bpmn-flows-zoom-eye{fill:none;pointer-events:all;width:100%;height:100%}.bpmn-flows-marker{fill:#6b6a6a}.bpmn-flows-path{fill:none;stroke-width:2px;stroke:#6b6a6a;opacity:.8}.bpmn-flows-gateway-icon,.bpmn-flows-task-icon{float:left;color:#6b6a6a;font-size:14px}.bpmn-flows-gateway-icon{float:left;font-size:18px;text-align:center;padding-top:15px}.bpmn-flows-gateway-icon span{margin:auto}.bpmn-flows-shadow{box-shadow:inset 0 0 1px 0 #6b6a6a}.bpmn-flows-circle-name,.bpmn-flows-lane-name,.bpmn-flows-path-name,.bpmn-flows-text{fill:#6b6a6a;text-anchor:middle;font-family:Verdana,Helvetica;font-size:12px;text-align:center}.bpmn-flows-lane-name{-webkit-transform:rotate(-90deg);transform:rotate(-90deg)}.bpmn-flows-icon{font-family:'Font Awesome 5 Free'}"]
                }] }
    ];
    /** @nocollapse */
    BpmnFlowsComponent.ctorParameters = function () { return [
        { type: BpmnFlowsService }
    ]; };
    BpmnFlowsComponent.propDecorators = {
        fileUrl: [{ type: Input, args: ['fileUrl',] }]
    };
    return BpmnFlowsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var BpmnFlowsModule = /** @class */ (function () {
    function BpmnFlowsModule() {
    }
    BpmnFlowsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        HttpClientModule
                    ],
                    providers: [HttpClient],
                    declarations: [BpmnFlowsComponent],
                    exports: [BpmnFlowsComponent]
                },] }
    ];
    return BpmnFlowsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

export { BpmnFlowsService, BpmnFlowsComponent, BpmnFlowsModule };

//# sourceMappingURL=bpmn-flows.js.map