import { HttpClient } from '@angular/common/http';
import { BpmnImporter } from './core/importer/bpmn.importer';
import { Scene } from './core/scene/scene';
import { BpmnElements } from './core/elements/bpmn.elements';
export declare class BpmnFlowsService {
    private http;
    bpmnElements: BpmnElements;
    bpmnImporter: BpmnImporter;
    scene: Scene;
    constructor(http: HttpClient);
    initialize(bpmnFile: string): void;
    bpmnDiagramParser(text: any): void;
    eventImportedBpmn(): void;
    eventRenderedBpmn(): void;
    getBpmnDiagram(bpmnFilePath: any): void;
    renderBpmn(): void;
}
