import { UserTaskRect } from './shape/user.task.rect';
import { StartEventCircle } from './shape/start.event.circle';
import { EndEventCircle } from './shape/end.event.circle';
import { MultiInstanceRect } from './shape/multi.instance.rect';
import { SequenceFlowPath } from './sequence/sequence.flow.path';
import { ExclusiveGatewayRhombus } from './shape/exclusive.gateway.rhombus';
import { ParallelGatewayRhombus } from './shape/parallel.gateway.rhombus';
import { ManualTaskRect } from './shape/manual.task.rect';
import { ScriptTaskRect } from './shape/script.task.rect';
import { LaneRect } from './shape/lane.rect';
import { ParticipantRect } from './shape/participant.rect';
export declare const BpmnTypes: {
    'userTask': typeof UserTaskRect;
    'scriptTask': typeof ScriptTaskRect;
    'manualTask': typeof ManualTaskRect;
    'startEvent': typeof StartEventCircle;
    'endEvent': typeof EndEventCircle;
    'subProcess': typeof MultiInstanceRect;
    'sequenceFlow': typeof SequenceFlowPath;
    'exclusiveGateway': typeof ExclusiveGatewayRhombus;
    'parallelGateway': typeof ParallelGatewayRhombus;
    'lane': typeof LaneRect;
    'participant': typeof ParticipantRect;
};
