import { BehaviorSubject } from 'rxjs';
import { BpmnElements } from '../elements/bpmn.elements';
export declare class BpmnImporter {
    private process;
    private diagram;
    private collaboration;
    private bpmnElements;
    bpmnElements$: BehaviorSubject<BpmnElements>;
    constructor(xml: any);
    private createLane;
    private createShape;
    private createSubProcess;
    private getElements;
    private getNodePosition;
    private htmlCollectionToArray;
    private importElement;
    private importSequenceFlow;
    private processCollaboration;
    private processBpmnProcess;
    private processDiagram;
    private processSequences;
    private processSequenceChild;
    private processShapes;
    private processShapeChild;
}
