import { BehaviorSubject } from 'rxjs';
import { BpmnElements } from '../elements/bpmn.elements';
export declare class Scene {
    private bpmnElements;
    private sceneClass;
    private centerEye;
    loaded$: BehaviorSubject<boolean>;
    private zoomBehaviour;
    private zoomEye;
    private shapes;
    private sequences;
    private svgScene;
    private svgSceneElements;
    private svgSceneShapes;
    private svgSceneSequences;
    private svgSceneDefs;
    constructor(bpmnElements: BpmnElements, sceneClass: string);
    init(): void;
    private calculateCenterEye;
    private calculatePath;
    private calculateTextposition;
    private loadDefs;
    private loadElements;
    private loadShapes;
    private loadSceneEngine;
    private loadSequences;
    private renderCircle;
    private renderRect;
    private renderRhombus;
    private renderSequence;
    private renderLane;
    private renderMultiInstance;
    private renderTask;
    private setCenterEye;
    private zoomed;
    private zoomEngine;
}
